unit Unit2;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, CYmPlayer, ComCtrls, mmsystem;

type
  TAboutBox = class(TForm)
    BitBtn1: TBitBtn;
    Image1: TImage;
    Memo1: TMemo;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Panel2: TPanel;
    TrackBar1: TTrackBar;
    SpeedButton1: TSpeedButton;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
         	m_player: CYmEngine;
  public
    { Public declarations }
  end;

var
  AboutBox: TAboutBox;

implementation

{$R *.dfm}
{$R extra.res}

var
 s_on, s_OK:boolean;

procedure TAboutBox.BitBtn1Click(Sender: TObject);
begin
AboutBox.Close;
end;

procedure TAboutBox.FormCreate(Sender: TObject);
var
  WOutCaps: TWAVEOUTCAPS;
begin
 FillChar(WOutCaps, SizeOf(TWAVEOUTCAPS), #0);
  if MMSYSERR_NOERROR = WaveOutGetDevCaps(0, @WOutCaps, SizeOf(TWAVEOUTCAPS))
    then begin
  s_OK:=true;
  s_on:=true;
	m_player := CYmEngine.Create;
  m_player.setPlayInLoop(true);
  m_player.MixerChannels:=modeABC;
  m_player.Volume:=128;
  SpeedButton1.Glyph.LoadFromResourcename(HInstance, 'V2');
  TrackBar1.Enabled:=true;
    if m_player.LoadFromRessource('FLYDREAM.YM') then
    m_player.setChipFrq(1773400)
    else begin
    s_OK:=false;
    s_on:=false;
    SpeedButton1.Glyph.LoadFromResourcename(HInstance, 'V1');
    FreeAndNil(m_player);
  end;
  end else begin
  s_OK:=false;
  s_on:=false;
  SpeedButton1.Glyph.LoadFromResourcename(HInstance, 'V1');
  TrackBar1.Enabled:=false;
  end;
end;

procedure TAboutBox.FormShow(Sender: TObject);
begin
if s_OK and s_on then
   	m_player.Play;
end;

procedure TAboutBox.FormDestroy(Sender: TObject);
begin
if s_OK then
   FreeAndNil(m_player);
end;

procedure TAboutBox.TrackBar1Change(Sender: TObject);
begin
m_player.Volume:=TrackBar1.Position;
end;

procedure TAboutBox.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if s_OK then
m_player.Stop;
end;

procedure TAboutBox.SpeedButton1Click(Sender: TObject);
begin
if s_OK then
if s_on then begin
s_on:=false;
m_player.Stop;
SpeedButton1.Glyph.LoadFromResourcename(HInstance, 'V1');
end else begin
s_on:=true;
m_player.Play;
SpeedButton1.Glyph.LoadFromResourcename(HInstance, 'V2');
end;
end;

end.
 
